class PersonalHonorsController < ApplicationController
  def index
    params = OrbitHelper.params
    honors = Honor.where(:is_hidden=>false).sort_for_frontend.page(OrbitHelper.params[:page_no]).per(OrbitHelper.page_data_count)
    fields_to_show = Page.where(:page_id => params[:page_id]).first.custom_array_field rescue []

    if fields_to_show.blank?
      fields_to_show = [
        "honor_type",
        "year",
        "award_name",
        "authors",
        "awarding_unit"
      ]
    end

    honor_list = []
    honors.each do |honor|
      t = []
      fields_to_show.each do |fs|
            case fs
            when "award_name"
              t << {"value" => "<a href='#{OrbitHelper.url_to_show(honor.to_param)}'>" + (honor.send(fs) rescue "") + "</a>"}
            when "honor_type"
              t << {"value" => (honor.send("honor_type").title rescue "")}
            when "authors"
              t << {"value" => (honor.send(:member_profile).name rescue "")}
            when "award_date"
              t << {"value" => (honor.send(fs).strftime("%Y/%m") rescue "")}
            else
              t << {"value" => (honor.send(fs) rescue "")}
            end
          end
        honor_list << {"personal_honors" => t}
    end
    
    headers = []
    fields_to_show.each do |fs|
      col = 2
      col = 3 if fs == "award_name"
      header =  fs == "authors" ? t("users.name") : t("personal_honor.#{fs}")
      headers << {
        "head-title" => header,
        "col" => col
      }
    end

    {
      "honors" => honor_list,
      "extras" => {"widget-title" => t("module_name.personal_honor")},
      "headers" => headers,
      "total_pages" => honors.total_pages
    }
  end

  def show
    params = OrbitHelper.params
    plugin = Honor.where(:is_hidden=>false).find_by(uid: params[:uid])
    fields_to_show = [
      "year",
      "honor_type",
      "award_name",
      "award_date",
      "country",
      "honoree",
      "awarding_unit",
      "keywords",
      "url",
      "note"
    ]

    {"plugin_datas"=>plugin.get_plugin_data(fields_to_show)}
  end

  def get_fields_for_index
      @page = Page.find(params[:page_id]) rescue nil
      @fields_to_show = [
        "year",
        "award_name",
        "awarding_unit",
        "honor_type",
        "award_date",
        "country",
        "keywords",
        "url",
        "note",
        "authors",
        "award_winner"
      ]
      @fields_to_show = @fields_to_show.map{|fs| [(fs == "authors" ? t("users.name") : t("personal_honor.#{fs}")), fs]}
      @default_fields_to_show = [
        "honor_type",
        "year",
        "award_name",
        "authors",
        "awarding_unit"
      ]
      render :layout => false
  end

  def save_index_fields
      page = Page.find(params[:page_id]) rescue nil
      page.custom_array_field = params[:keys]
      page.save
      render :json => {"success" => true}.to_json
  end
end